<!--
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<div class="ddp-wrap-rules-flow" style="position:relative; top:0; left:0; right:0; bottom:0; width:inherit; height:100%;">
  <!-- title -->
  <div class="ddp-box-title">
    <ul class="ddp-rule-tab">
      <li [ngClass]="{ 'ddp-selected': tabNumber === 0 }" (click)="changeTab(0)">
        <a href="javascript:">{{'msg.dp.btn.tab.rule' | translate }} ({{ruleList.length}})</a>
      </li>
      <li [ngClass]="{ 'ddp-selected': tabNumber === 1 }" (click)="changeTab(1)">
        <a href="javascript:">{{'msg.dp.btn.tab.snapshot' | translate }} ({{snapshotList && snapshotList.length || 0}})
          <em class="ddp-icon-selected" *ngIf="checkIfIntervalExists()"></em>
        </a>
      </li>
    </ul>
    <div class="ddp-ui-buttons" *ngIf="0 === tabNumber">
      <a href="javascript:" class="ddp-icon-refresh" (click)="transformAction('UNDO')" [ngClass]="{'ddp-disabled': !undoable}"></a>
      <a href="javascript:" class="ddp-icon-refresh2" (click)="transformAction('REDO')" [ngClass]="{'ddp-disabled': !redoable}"></a>
    </div>
  </div>
  <!-- //title -->

  <div class="ddp-ui-rule-flow" *ngIf="0 === tabNumber">
    <ul class="ddp-list-rule2">

      <li *ngFor="let rule of ruleList; let idx = index"
          (click)="jumpRule(idx)"
          [ngClass]="{'ddp-disabled2':rule.isValid, 'ddp-selected': (idx === selectedRuleIdx), 'ddp-edit' : isDisableHover(idx) }">

        <div class="ddp-view-data" [ngClass]="{'ddp-edit': rule.isEditMode }" >
          <span class="ddp-data-type">
            <em class="ddp-ui-round">{{rule.alias}}</em>
          </span>
          <div class="ddp-ui-code" title="{{idx !== 0 ? rule.ruleString : null}}">
            {{rule.simplifiedRule !== '' ? rule.simplifiedRule : rule.ruleString}}
          </div>
          <div class="ddp-ui-edit-button" *ngIf="idx !== 0">
            <span class="ddp-btn-icon" (click)="$event.stopImmediatePropagation(); editRule(rule)">
              <em class="ddp-icon-edit"></em>
            </span>
            <span class="ddp-btn-icon" (click)="$event.stopImmediatePropagation(); deleteRule(idx)">
              <em class="ddp-icon-del"></em>
            </span>
            <span class="ddp-btn-link">
              <a href="javascript:" class="ddp-link-cancel"
                 (click)="$event.stopImmediatePropagation(); cancelEditMode(rule, idx)">{{'msg.comm.btn.cancl' | translate }}</a>
            </span>
          </div>
          <!-- //button -->
          <!-- tooltip -->
          <!--<div class="ddp-ui-tooltip-info" *ngIf="idx !== 0">-->
            <!--<em class="ddp-icon-view-top"></em>-->
            <!--{{rule.ruleString}}-->
          <!--</div>-->
          <!-- //tooltip -->
        </div>
        <div class="ddp-wrap-line-add " [ngClass]="{'ddp-selected' : rule.isInsertStep}" *ngIf="!rule.isEditMode">
          <div class="ddp-line-add">
            <span class="ddp-txt" (click)="$event.stopImmediatePropagation(); insertStep(rule)">{{ 'msg.dp.btn.insert.rule' | translate }}</span>
          </div>
          <!-- info -->
          <div class="ddp-input-info">
            {{'msg.dp.ui.insert.rule.below' | translate }}
            <a href="javascript:" class="ddp-link-cancel" (click)="$event.stopImmediatePropagation(); cancelInsertMode(rule, idx)">{{'msg.comm.btn.cancl' | translate }}</a>
          </div>
          <!-- //info -->
        </div>
      </li>
    </ul>
  </div>
  <app-rule-snapshot-list *ngIf="1 === tabNumber"
                          (retrieveAllSnapshots)="setCanceledStatus($event)"
                          (snapshotDetailEvent)="snapshotDetail($event)"
                          (snapshotListRefreshEvent)="getSnapshotWithInterval(dsId)"
                          (snapshotIntervalStopEvent)="clearSnapshotInterval()">
  </app-rule-snapshot-list>
</div>
